  function switchTo(pExpObj) {
    var slotTables = document.all("slotTable")
    var slotExps   = document.all("slotExp");
    for (slotIdx=0; slotIdx<slotExps.length; slotIdx++) {
       var tableObj= slotTables[slotIdx];
       var expObj  = slotExps[slotIdx];
       if (expObj == pExpObj)
         tableObj.style.display = "";
       else
         tableObj.style.display = "none";
    }
    pExpObj.focus();
  }

  function fillValue(slotIdx, checkObj, fill, keys)
  {
    var slotExp  = document.all("slotExp")[slotIdx];
    var slotKeys = document.all("slotKeys")[slotIdx];
    if (checkObj.checked) {
      if (slotExp.value.indexOf(fill) < 0)
        slotExp.value  = trim(fill+" "+slotExp.value);
      if (slotKeys.value.indexOf(keys) < 0)
        slotKeys.value = keys+" "+slotKeys.value;
    }
    else {
      slotExp.value  = trim(slotExp.value.replace(fill, ""));
      slotKeys.value = slotKeys.value.replace(keys, "");
    }
    slotExp.focus();
  }
  
  function doQuery() {
    command = makeCommand();
    document.all("showCommand").innerText=command;
    document.all("command").value = command;
    return true;
  }  
  
  function makeCommand() {
    var showPath = document.all("showPath").value;
    var sortPath = document.all("sortBy").value;;
    var sortOrder= document.all("order").value;
    var query    = document.all("query").value;
    var slotExp  = document.all("slotExp");
    var slotKeys=document.all("slotKeys");
    var slotPath = document.all("slotPath");
    var queryExp = "%"+query;
    for (slotIdx=0; slotIdx<slotExp.length; slotIdx++) {
      var path  = slotPath[slotIdx].value;
      exp  = trim(slotExp[slotIdx].value);
      keys = trim(slotKeys[slotIdx].value);
      if (keys.length > 0) {
      	if (keys.indexOf(exp) >= 0)
          exp = keys;
        else
          exp = exp+"+"+keys;
      }
      exp = replaceAll(exp, " ", "+");
      exp = replaceAll(exp, ",", "+");
      if (exp.length > 0)
        queryExp  = queryExp+";"+path+"%"+exp;
    }
    command = "<query>"+showPath+";"+queryExp+"</query><sortBy>"+sortPath+"</sortBy><order>"+sortOrder+"</order>";
    return command;
  }  

  function trim(pStr) {
    pStr = pStr.replace('\t', ' ');
    pStr = pStr.replace('\r', ' ');
    pStr = pStr.replace('\n', ' ');
    while (pStr.charAt(0)==' ')
      pStr = pStr.substr(1);
    while (pStr.length > 0 && pStr.charAt(pStr.length-1)==' ')
      pStr = pStr.substr(0, pStr.length-1);
    return pStr;
  }
  
  function replaceAll(pStr, fromPat, toPat) {
    while (true) {
      rzStr = pStr.replace(fromPat, toPat);
      if (rzStr == pStr)
        break;
      pStr = rzStr;
    }
    return rzStr;
  }
