<?xml version="1.0" encoding="big5"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:template match="/frame">
<xsl:variable name="language" select="@language"/>
<HTML>
<head>
<STYLE>
 BODY  {font-size:16px;}
 DIV   {margin-left:10px;font-size:16px;}
 SPAN  {margin-top:10px;font-size:16px;}
 .MENU {margin:0;font-size:16px;}
 .MENU_INPUT {style="width:80px;border:1px;}
 TABLE {color:white;background-color:#3366cc;font-size:16px;}
 INPUT {font-size:16px;}
 SELECT {font-size:16px;}
</STYLE>
<SCRIPT TYPE="text/javascript" LANGUAGE="javascript" SRC="frame.js"></SCRIPT>
</head>
<BODY leftMargin="0" topMargin="0" style="">
<!-- main query box -->
<FORM method="post" onsubmit="JavaScript:return doQuery();"> <!--action="XQueryer.jsp"-->
<xsl:attribute name="action"><xsl:value-of select="@submitTo"/></xsl:attribute>
<TABLE width="100%" style="background-color:#3366cc;"><TR>
<TD></TD>
<TD width="55%" align="right">
  <INPUT type="text"   id="query"   style="width:200"/>
  <INPUT type="hidden" id="command" name="command"/>
  <INPUT type="hidden" id="showPath" name="showPath">
    <xsl:attribute name="value"><xsl:value-of select="@showPath"/></xsl:attribute>
  </INPUT>
  <INPUT type="hidden" id="db" name="db">
    <xsl:attribute name="value"><xsl:value-of select="@database"/></xsl:attribute>
  </INPUT>
  <span style="width:10"/>
  <INPUT type="submit" value="Submit"/>
  <span style="width:5"/>
  <INPUT type="reset"/>
</TD>
<TD width="40%" align="right" style="color:white;">
  SortBy :
  <SELECT id="sortBy" name="sortBy" style="width:100px">
    <OPTION value=""></OPTION>
    <xsl:for-each select="//*[@sortable='yes']">
      <OPTION>
        <xsl:attribute name="value"><xsl:value-of select="@path"/></xsl:attribute>
        <xsl:value-of select="@slot"/>
      </OPTION>
    </xsl:for-each>
  </SELECT>
  <SELECT id="order" name="order">
    <OPTION value="descrease"> - </OPTION>
    <OPTION value="increase">  + </OPTION>
  </SELECT>
</TD></TR></TABLE>
<TABLE width="100%" style="background-color:#3366cc;"><TR><TD>
<xsl:for-each select="//*[@menu='yes']">
   <span class="MENU" style="width:190px;">
     <input style="width:100px;color:white;border:0;background-color:#3366cc;text-align:right" type="text">
       <xsl:attribute name="value"><xsl:value-of select="@slot"/></xsl:attribute>
     </input>
     <span class="MENU" style="width:5px"/>
     <input id="slotExp"  type="text" style="width:80px;background-color:#3366ee;border:1px;color:yellow;" onFocus="JavaScript:switchTo(this);"/>
     <input id="slotKeys" type="hidden"/>
     <input id="slotPath" type="hidden">
       <xsl:attribute name="value"><xsl:value-of select="@path"/></xsl:attribute>
     </input>
   </span>
</xsl:for-each>
</TD></TR></TABLE>
<xsl:for-each select="//*[@menu='yes']">
  <table id="slotTable" width="100%" style="display:none;background-color:#ffffff;"><tr><td valign="top">
  <xsl:variable name="slotID" select="position()-1"></xsl:variable>
  <xsl:for-each select=".//*[@value!='']">
    <span style="width:160px;height:40px;color:brown;vertical-align:top;">
      <input type="checkbox">
        <xsl:attribute name="onclick">
          JavaScript:fillValue(<xsl:value-of select="$slotID"/>, this, '<xsl:value-of select="@value"/>', '<xsl:value-of select="@keys"/>');
        </xsl:attribute>
      </input>
      <xsl:value-of select="@value"/>
      <BR/>
      <xsl:if test="@image!=''">
        <img>
          <xsl:attribute name="src">picture/<xsl:value-of select="@image"/></xsl:attribute>
        </img>
      </xsl:if>
    </span>
  </xsl:for-each>
  </td></tr>
  <tr><td>
    <xsl:for-each select=".//hit">
      <li><xsl:value-of select="."/></li>
    </xsl:for-each>
  </td></tr>
  </table>
</xsl:for-each>
<!-- all slot query box -->
</FORM>
<div id="showCommand" style="font-size:12px;color:#525252"></div>
</BODY>
</HTML>
</xsl:template>
</xsl:stylesheet>